<!----------------------------------------------------------------------------------------------------------------------
  -- Environments Dropdown
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div id="environments-dropdown">
        <BDropdown class="me-2" right>
            <template #button-content>
                <Fa
                    v-if="currentEnv"
                    :icon="getConnectionStatusIcons(currentEnv.id).icon"
                    :class="getConnectionStatusIcons(currentEnv.id).iconClass"
                />
                {{ currentName }}
                <span v-if="currentEnv">
                    <Fa v-if="isSecure" icon="lock" class="text-warning" />
                    <Fa v-else icon="lock-open" />
                </span>
            </template>
            <BDropdownItem @click="editEnvironments()">
                <Fa :icon="[ 'far', 'edit' ]" />
                Edit Environments
            </BDropdownItem>
            <BDropdownItem v-if="showPluginMenu" @click="editPlugins()">
                <Fa :icon="[ 'far', 'puzzle-piece-simple' ]" />
                Edit Plugins
            </BDropdownItem>
            <BDropdownDivider v-if="userEnvs.length" />
            <BDropdownHeader v-if="authEnabled && systemEnvs.length && userEnvs.length">
                User Environments
            </BDropdownHeader>
            <BDropdownItem
                v-for="env in userEnvs"
                :key="env.id"
                :active="isActive(env.id)"
                @click="selectEnv(env.id)"
            >
                <Fa
                    :icon="getConnectionStatusIcons(env.id).icon"
                    :class="getConnectionStatusIcons(env.id).iconClass"
                />
                {{ env.name }}
                <Fa v-if="env.secure" icon="lock" class="text-warning" />
                <Fa v-else icon="lock-open" class="text-muted" />
            </BDropdownItem>
            <BDropdownDivider v-if="systemEnvs.length" />
            <BDropdownHeader v-if="authEnabled && systemEnvs.length && userEnvs.length">
                System Environments
            </BDropdownHeader>
            <BDropdownItem
                v-for="env in systemEnvs"
                :key="env.id"
                :active="isActive(env.id)"
                @click="selectEnv(env.id)"
            >
                <Fa
                    :icon="getConnectionStatusIcons(env.id).icon"
                    :class="getConnectionStatusIcons(env.id).iconClass"
                />
                {{ env.name }}
                <Fa v-if="env.secure" icon="lock" class="text-warning" />
                <Fa v-else icon="lock-open" class="text-muted" />
            </BDropdownItem>
            <BDropdownDivider v-if="environments.length === 0" />
            <BDropdownText v-if="environments.length === 0" class="text-center">
                No environments.
            </BDropdownText>
        </BDropdown>

        <!-- Modals -->
        <AddEditModal ref="addEditModal" />
        <EditPluginsModal ref="editPluginsModal" />
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { computed, ref, watch } from 'vue';
    import { useObservable } from '../../lib/composables/rxjs.js';
    import { useToastController } from 'bootstrap-vue-next';

    // Managers
    import authMan from '../../lib/managers/auth.js';
    import envMan from '../../lib/managers/environments.js';
    import pluginMan from '../../lib/managers/plugin.js';

    // Resource Access
    import sioRA from '../../lib/resource-access/sio.js';

    // Components
    import AddEditModal from './addEditEnvModal.vue';
    import EditPluginsModal from './editPluginsModal.vue';

    // Utils
    import { sortBy } from '../../../common/utils/misc.js';

    const { show } = useToastController();

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const addEditModal = ref<typeof AddEditModal>(null);
    const editPluginsModal = ref<typeof EditPluginsModal>(null);

    //------------------------------------------------------------------------------------------------------------------
    // Observables
    //------------------------------------------------------------------------------------------------------------------

    const authEnabled = useObservable(authMan.authEnabled$);
    const currentEnv = useObservable(envMan.currentEnv$);
    const environments = useObservable(envMan.environments$);
    const pluginConfigs = useObservable(pluginMan.configs$);
    const connectionStatus = useObservable(sioRA.connectionStatus$);

    //------------------------------------------------------------------------------------------------------------------
    // Computed
    //------------------------------------------------------------------------------------------------------------------

    const currentName = computed(() =>
    {
        return currentEnv.value ? currentEnv.value.name : 'Environments';
    });

    const isSecure = computed(() => currentEnv.value?.secure ?? false);

    const userEnvs = computed(() => environments.value
        .filter((env) => env.accountID > 0)
        .sort(sortBy('name')));

    const systemEnvs = computed(() => environments.value
        .filter((env) => env.accountID === null)
        .sort(sortBy('name')));

    const showPluginMenu = computed(() => pluginConfigs.value?.length > 0);

    //------------------------------------------------------------------------------------------------------------------
    // Methods
    //------------------------------------------------------------------------------------------------------------------

    function selectEnv(id : string) : void
    {
        envMan.selectEnv(id);
    }

    function isActive(id : string) : boolean
    {
        return id === (currentEnv.value?.id ?? '');
    }

    function editEnvironments() : void
    {
        addEditModal.value.show();
    }

    function editPlugins() : void
    {
        editPluginsModal.value.show();
    }

    function getConnectionStatusIcons(envId : string) : { icon : string, iconClass : string }
    {
        const status = connectionStatus.value.find((cs) => cs.envId === envId);
        let icon = 'fa-solid fa-plug-circle-xmark';
        let iconClass = 'text-muted';
        switch (status?.status)
        {
            case 'connected':
                icon = 'fa-solid fa-plug';
                iconClass = 'text-success';
                break;
            case 'connecting':
                icon = 'fa-solid fa-plug-circle-bolt';
                iconClass = 'text-warning fa-beat';
                break;
        }

        if(status?.error)
        {
            iconClass = 'text-danger';
        }

        return { icon, iconClass };
    }

    //------------------------------------------------------------------------------------------------------------------
    // Watch
    //------------------------------------------------------------------------------------------------------------------

    watch(connectionStatus, (value) =>
    {
        const errors = value.filter((x) => x.error).map((x) => x.error);
        errors.forEach((error) =>
        {
            show?.({ props: { title: 'Environment Error', body: error, variant: 'danger', pos: 'bottom-start' } });
        });
    });
</script>

<!--------------------------------------------------------------------------------------------------------------------->
